import bstsize

class BST(bstsize.BST):
    """
    Adds select method to BST, starting with code from bstsize.
    """

    def select(self, index):
        """
        Takes a 1-based index, and returns the element at that index,
        or None if the index is out-of-bounds.
        """
        rank = 0
        node = self.root
        while node is not None:
            node_rank = rank + bstsize.size(node.left) + 1
            if index == node_rank:
                return node
            elif index < node_rank:
                node = node.left
            else:
                node = node.right
                rank = node_rank
        return None
